
#include <target_syssvc.h>
#include <syssvc/serial.h>
#include "ntshell/ntshell.h"
#include "ntshell/ntlibc.h"

ntshell_t ntshell;

int func_read(char *buf, int cnt);
int func_write(const char *buf, int cnt);
int func_ntshell(const char *text);

int func_read(char *buf, int cnt)
{
    return serial_rea_dat(SIO_PORTID, (char_t *)buf, cnt);
}

int func_write(const char *buf, int cnt)
{
    return serial_wri_dat(SIO_PORTID, (const char_t *)buf, cnt);
}

int func_cbfunc(const char *text)
{
#define MSG_PRI "The user input command is '"
#define MSG_POST "'.\n"
    serial_wri_dat(
            SIO_PORTID,
            (const char_t *)MSG_PRI,
            ntlibc_strlen(MSG_PRI));
    serial_wri_dat(
            SIO_PORTID,
            (const char_t *)text,
            ntlibc_strlen(text));
    serial_wri_dat(
            SIO_PORTID,
            (const char_t *)MSG_POST,
            ntlibc_strlen(MSG_POST));
    return 0;
}

void main_task(intptr_t exinf)
{
    serial_opn_por(SIO_PORTID);
    serial_ctl_por(SIO_PORTID, (IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV));
    ntshell_execute(&ntshell, func_read, func_write, func_cbfunc);
}

